﻿

XIncludeFile "../Library/Lizard.pbi"


; Lizard always has to be initialized first.
If Lizard::Initialize("../Library")
	Debug "Lizard kernel has been initialized. Version "+Lizard::Version()
Else
	Debug "Lizard kernel initialization failed!"
	End
EndIf


Define Input.s, Output.s, *Expression


Input.s = "1+2*3"
*Expression = Lizard::InputExpression(Input)               ; Parse a string into a Lizard expression (without evaluation).
Debug "Input = " + Lizard::OutputExpression(*Expression)   ; Output this expression. The expression keeps still valid.

*Expression = Lizard::EvaluateExpression(*Expression)      ; Evaluate a Lizard expression into a resulting expression. The old expression exists no more.
Debug "Output = " + Lizard::OutputExpression(*Expression)  ; Output this expression. The expression keeps still valid.

Lizard::FreeExpression(*Expression)                        ; Free the expression to prevent memory leaks, if it is no longer needed.


; Quit Lizard.
Lizard::Terminate()


; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; EnableXP
; EnableCompileCount = 111
; EnableBuildCount = 0