﻿

Enumeration
	#File
EndEnumeration


XIncludeFile "../Library/Lizard.pbi"


; Lizard always has to be initialized first.
If Lizard::Initialize("../Library")
	Debug "Lizard kernel has been initialized. Version "+Lizard::Version()
Else
	Debug "Lizard kernel initialization failed!"
	End
EndIf



Define Input.s, Output.s


;- Import Dataset
If ReadFile(#File, "Example8_Dataset.txt")
	Lizard::SetString("content", ReadString(#File, #PB_File_IgnoreEOL|#PB_UTF8))
	CloseFile(#File)
EndIf
Debug "____________________________________________________"
Debug "Import Dataset from a file"
Debug "content = " + Lizard::Evaluate("content") ; Variable "content" contains the content of the file as a string.


;- Translate content to a table (list of lists)
Debug "____________________________________________________"
Debug "Translate content to a table (list of lists)"
Input = ~"data = Split(#, \"\\t\") &/@ Split(content, \"\\r\\n\")"
Debug "data = " + Lizard::Evaluate(Input) ; Variable "data" contains now the content of the file as a list of lists.


;- Remove the first element (headers of the columns)
Debug "____________________________________________________"
Debug "Remove the first element (headers of the columns)"
Input = ~"data = data[2..-1]"
Debug "data = " + Lizard::Evaluate(Input) ; Variable "data" contains now only the real items


;- Convert the "Scores" to a number
Debug "____________________________________________________"
Debug "Convert the 'Scores' to a number"
Input = ~"data = {#[1], #[2], ToInteger(#[3])} &/@ data"
Debug "data = " + Lizard::Evaluate(Input)


;- Sort the data over scores
Debug "____________________________________________________"
Debug "Sort the data over scores"
Input = ~"data = Sort(data, #1[3] >= #2[3] & )"
Debug "data = " + Lizard::Evaluate(Input)


;- Sort the data over name
Debug "____________________________________________________"
Debug "Sort the data over name"
Input = ~"data = Sort(data, Order(#1[1], #2[1]) & )"
Debug "data = " + Lizard::Evaluate(Input)


;- Select all Group B
Debug "____________________________________________________"
Debug "Select all Group B"
Input = ~"data = Select(data, #[2] == \"B\" & )"
Debug "data = " + Lizard::Evaluate(Input)


;- Pick all names
Debug "____________________________________________________"
Debug "Pick all names"
Input = ~"names = data[All, 1]"
Debug "names = " + Lizard::Evaluate(Input)


;- Return the maximum score number
Debug "____________________________________________________"
Debug "Return the maximum score number"
Input = ~"Max(data[All,3])"
Debug "max = " + Lizard::Evaluate(Input)



; Quit Lizard.
Lizard::Terminate()


; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; EnableXP
; EnableCompileCount = 195
; EnableBuildCount = 0